#!/usr/bin/perl 
#	The mayority of the code was ripped from qhttp. The idea is the 
#	tool. This software try to identify directories in a web server
# 	This will be worthly if you are trying to audit a system, because
#	many people often forget directories browseables with a lot
# 	of information.
#	Fill the browsing.cfg with the directories you want to search. The
#	result of the scan will be writen in result.txt
#
#	Sintaxis:  busca_browsing.pl GET http://www.micrososft.com
#
# 	1999 Mephystos.....mephystos@virsoft.com

# --- PREAMBLE

use Socket;
use FileHandle;
use Carp;
use Getopt::Long;

# --- Subroutines

sub info;
sub pack_socket_addrs;
sub tcp_connect;
sub send_msg;
sub decode_http_response;
sub encode_base64;
sub http_get;

# --- Global Variables

($Version)= ' $Revision: 0.1 $ ' =~ m|(\d+.\d+)|;
                                # Version from RCS

$Eol="\r\n";                    # CR-LF End of Line marker
$UserAgent="Qhttp/$Version";    # User Agent
$Blocksize=4096;                # Size of blocks when transfering data

$Host="";                       # Host name
$Port="";                       # Port to which to connect
$Protocol="";                   # Protocol to use (must be HTTP)
$Path="";                       # Components of Path } from URL +
$PathExtra="";                  #                    } added by program
$Auth="";                       # Authentication string (username:passwd)
$Method="";                     # HTTP Method (GET/HEAD/PUT/DELETE)
$ContentType="";                # Type of file
$ContentLength=0;               # Length of file

$ThisAddr="";                   # } Packed addresses for either
$ThatAddr="";                   # } end of the TCP connection

$Verbose=0;                     # Flag: Verbose output?
$Help=0;                        # Print help message and exit
$UploadToDir=0;                 # Uploading to directory?

%RetCodeMap=("200" => "OK",
             "201" => "OK - Created",
             "202" => "OK - Accepted",
             "204" => "OK - No Further Information",
             "301" => "Moved Permenantly",
             "302" => "Moved Temporarily",
             "304" => "Not Modified",
             "400" => "Bad Request",
             "401" => "Unauthorized",
             "403" => "Forbidden",
             "404" => "Not Found",
             "500" => "Internal Server Error",
             "501" => "Not Implimented",
             "502" => "Bad Gateway",
             "503" => "Service Unavailable");
                                # Meanings of HTTP return codes

%MethodMap=("GET"    => \&http_get,
            "HEAD"   => \&http_get);

# --- MAIN


# --- Decode command line arguments
&GetOptions("v"   => \$Verbose, "verbose" => \$Verbose,
            "a=s" => \$Auth,    "auth=s"  => \$Auth,
            "h"   => \$Help,    "help"    => \$Help);

help() if $Help;
help() if $#ARGV < 1;

# --- Decode method
($Method=shift) =~ tr/[a-z]/[A-Z]/;
croak "$Method is not a valid method"
    if !exists $MethodMap{$Method};

# --- Decode URL
($Protocol, $Host, $Port, $Path)=url_split(shift);
croak "Only http://... type URLs supported" if $Protocol ne "http";
$Port=80 if !$Port;             # Ensure $Port is set...
croak "Invalid URL" unless $Port =~ /\d+/;
                                # ... and is a number...
$Path="/" if !$Path;            # ... and $Path is valid
$UploadToDir=1 if $Path =~ m|/$|;


open(buscar,"browsing.cfg") || die "Error, no browsig directories to look  for\n";
open(salida,">result.txt") || die "Error generating output file";


# --- Get list of files
@Files=@ARGV;
croak "Cannot specify more than one file for any method but PUT"
    if ($#Files > 0 && $Method ne "PUT");
croak "URL must end in / if multiple files are to be PUT"
    if ($#Files > 0 && !$UploadToDir);

# --- Get addresses for use with tcp_connect
($ThisAddr, $ThatAddr)=pack_socket_addrs($Host, $Port);

# --- Call the appropriate subrouting for each method for each file
#     specified on the command line.
@Files=("-") if $#Files < 0;

# modified to look for every directory
print salida "Interesting directories in $Host\n\n";
while(<buscar>)
{
    $PathExtra=$_;
    chop($PathExtra);
    &{$MethodMap{$Method}} ($PathExtra);
                                # Call the subroutine assoc with $Method
}
close (salida);
exit 0;

# --- SUBROUTINES

# --- info
#
#     Print an informative message

sub info
{
    print STDERR "$0: @_\n";
}

# --- help
#
#     Help message

sub help
{
    print STDERR << "END"
$0: Fetch, update and manipulate files on a remote HTTP server.

Usage:
    $0 [\<options\>] get \<url\>

END
;
    exit;
}

# --- pack_socket_addrs
#
#     Packs the addresses needed to connect this host
#     to port number $_[1] on host $_[0]
#

sub pack_socket_addrs
{
    my($host, $port)=($_[0], $_[1]);
    my($remote_addr, $thisend, $thatend);

    # --- Sanity check
    croak "pack_socket_addrs: No hostname" if $host eq "";
    croak "pack_socket_addrs: Port should be a number" if $port =~ /\D+/;

    # --- Get name and address of local and remote hosts
    $remote_addr=inet_aton($host);
    $thisend=pack_sockaddr_in(    0, INADDR_ANY);
    $thatend=pack_sockaddr_in($port, $remote_addr);

    return ($thisend, $thatend);
}

# --- tcp_connect
#
#     Make a TCP connection on a filehandle called $_[0] between
#     two packed addresses passed as $_[1] and $_[2]

sub tcp_connect
{
    my $proto=getprotobyname('tcp');
    my($sockname, $thisend, $thatend)=($_[0], $_[1], $_[2]);


    # --- Alias $sockhandle to filehandle corresponding
    #     to $sockname
    my $sockhandle=*$sockname;

    # --- Make the connection
    socket($sockhandle, PF_INET, SOCK_STREAM, $proto);
    bind($sockhandle, $thisend)    || croak "tcp_connect(bind): $!";
    connect($sockhandle, $thatend) || croak "tcp_connect(connect): $!";
}

# --- send_msg
#
#     Send a message $_[1] via the socket called $_[0]
#

sub send_msg
{
    my $sockname=$_[0];
    my $msg=$_[1];
    my $sockhandle=*$sockname;

    send $sockhandle, $msg . $Eol, 0;
    info "SENT: $msg" if $Verbose;
}

# --- send_http_request
#
#     Send the request defined in the global variables
#       $Method
#       $Path
#       $UserAgent
#       $ContentType
#       $ContentLength
#     to a TCP connection on SOCK_HTTP

sub send_http_request
{
    SOCK_HTTP->autoflush(1);
    send_msg SOCK_HTTP, "$Method $Path$PathExtra HTTP/1.0";
    #info "$Method $Path$PathExtra";
    send_msg SOCK_HTTP, "User-Agent: $UserAgent"  if $UserAgent;
    send_msg SOCK_HTTP, "Authorization: Basic " .
        encode_base64($Auth)
            if $Auth;
    send_msg SOCK_HTTP, "Content-Type: $ContentType"   if $ContentType;
    send_msg SOCK_HTTP, "Content-Length: $ContentLength"
        if $ContentLength > 0;
    send_msg SOCK_HTTP, "";
    SOCK_HTTP->flush();
}

# --- decode_http_response
#
#     Read response from SOCK_HTTP and decode it;
#     Returns hash containing response, status code is in
#     element called "STATUS";

sub decode_http_response
{
    my %resp=();
    my ($key, $val, $line, $status);

    while (1) {
        $_=<SOCK_HTTP>;
        last if defined $_;
    }

    s/$Eol$//;                  # Remove trailing $Eol;
    info "RECV: $_" if $Verbose;;

    m|HTTP/\d\.\d *(\d{3}?)| || croak "Not a HTTP/1.x response";

    $status=$1;
    while(<SOCK_HTTP>) {
        s/$Eol$//;                      # Remove trailing $Eol;
        info "RECV: $_" if $Verbose;
        last if /^$/;
        ($key, $val) = m{(\S*): (.*)};
        $resp{$key}=$val;
    }

#    info "STATUS: $status ($RetCodeMap{$status})";

    # --- Authorisation
    if ($status == "401") {
        my ($realm) =
            ($resp{"WWW-Authenticate"} =~ m|realm="(.*)"|);
        info "AUTHORISATION required for $realm";
    };

    # --- Redirection
    if ($status =~ /3\d\d/) {
       # info "REDIRECT to " . $resp{"Location"};
	info "********   ---> Present.....$PathExtra  <---  *********";
	print salida "$PathExtra\n";
    } else
	{info "Not Present...$PathExtra";}

    $resp{"STATUS"}=$status;
    return %resp;
}

# --- http_get
#
#     Send an HTTP GET/HEAD style request, writing the results to a file
#     passed as $_[0];
#

sub http_get
{
    tcp_connect(SOCK_HTTP, $ThisAddr, $ThatAddr);
    send_http_request();
    decode_http_response();
    close SOCK_HTTP;
}



# --- url_split
#
#     Splits a URL passed as $_[0] into <protocol> <addr> <port>
#     and <path> parts and returns all four as a list
#

sub url_split
{
    my($protocol, $host, $port, $path);
    my $url=$_[0];

    $url =~ m{(\w+)://([-\w\.]+):?(\d*)(/?.*)};
    ($protocol, $host, $port, $path) = ($1, $2, $3, $4);
    return ($protocol, $host, $port, $path);
}

        


